#pragma once

#include <cstddef>
#include <exception>

template<typename T>
class Array
{
    private:
        T* _arr;
        unsigned int _size;
    
    public:

        Array():
            _arr(new T[0]),
            _size(0)
        {};
        
		Array(unsigned int n):
            _arr(new T[n]),
            _size(n)
        {};
        
		Array(const Array& src)
        {
            this->_arr = NULL;
            *this = src;
        };

        ~Array()
        {
            delete[] this->_arr;
        };

        Array& operator=(const Array& src)\
        {
            if (this == &src)
                return *this;
            delete[] this->_arr;
            this->_size = src._size;
            this->_arr = new T[src._size];
            for (size_t i = 0; i < src._size; i++)
                this->_arr[i] = src._arr[i];
			return *this;
        };

        T& operator[](unsigned int index) const
        {
            if (index >= _size)
				throw std::exception();
			return this->_arr[index];
        };

        unsigned int size() const
        {
        	return this->_size;
        };
};
