#include "Array.hpp"
#include <exception>
#include <iostream>

int main()
{
	std::cout << "Create with 0 size" << std::endl;
	{
		Array<int> t(0);
	}
	std::cout << std::endl;
	
	std::cout << "Access to invalid index ";
	{
		Array<int> t(0);
		try
		{
			t[0];
			std::cout << "failed !" << std::endl;
		}
		catch (std::exception& e)
		{
			std::cout << "success !" << std::endl;
		}
	}

	std::cout << "Fill and get" << std::endl;
	{
		unsigned int size = 10;
		Array<int> t(size);
		for (unsigned int i = 0; i != size; i++)
			t[i] = i;
		for (unsigned int i = 0; i != size; i++)
			std::cout << t[i] << std::endl;
	}
	std::cout << std::endl;
	
	std::cout << "Copy and get" << std::endl;
	{
		unsigned int size = 10;
		Array<int> t(size);
		for (unsigned int i = 0; i != size; i++)
			t[i] = i;
		Array<int> b(t);
		for (unsigned int i = 0; i != size; i++)
			std::cout << b[i] << std::endl;
	}
	std::cout << std::endl;

	std::cout << "operator = and get" << std::endl;
	{
		unsigned int size = 10;
		Array<int> t(size);
		for (unsigned int i = 0; i != size; i++)
			t[i] = i;
		Array<int> b;
		b = t;
		for (unsigned int i = 0; i != size; i++)
			std::cout << b[i] << std::endl;
	}
	std::cout << std::endl;
}
